/*
  Melody_alien

  Plays 9 nelodies from ZX-Spectrum games
  Alien-8 and Knightlore

  circuit:
  
  Piezo-speaker on digital pin 8

  created 14 Feb 2020
  
  by Dmitriy Korabelnikov aka Deckard of Atomic Destruction
  e-mail:
  d_korabelnikov@mail.ru
  site:
  http://atd-group.narod.ru
*/  

#include "freq.h"
#include "notes.h"
//Place your beeper pin number here
const int buzzer = 8;

void toneWithDelay (uint8_t _pin, unsigned int frequency, unsigned long duration)
{
  unsigned long TimeMs, TimeUs;
  unsigned int Micros;
  char PinValue;
  
  PinValue = 0;
  TimeMs = millis();
  Micros = 500000L / frequency;
  while (!((millis() - TimeMs) >= duration)) {
    TimeUs = micros();
    while (!((micros() - TimeUs) >= Micros));
    PinValue = ~PinValue;
    if (frequency) digitalWrite(_pin, PinValue);
  }
  digitalWrite(_pin, 0);
} 

void play(unsigned char *melody)
{unsigned char d;unsigned int f,i;unsigned long t;
for (i=0;d=pgm_read_byte(melody+i), d != 255;i++)  {t=125*(1 << ((d >> 6) & 3)); f=pgm_read_word(freq+((d & 0x3F)-12));
toneWithDelay(buzzer,f,t);}
}

void setup()
{unsigned char i,*p; 
 pinMode(buzzer,OUTPUT);for(i=0;i<9;i++) {p=pgm_read_word(notes_table+i);play(p);delay(2000);}
}

void loop()
{}


